package cpcns.utils;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import cpcns.base.common.util.JsonWithJacksonUtils;
import cpcns.utils.DangAnZhengLiUtil;
import cpcns.utils.DateUtil;
import cpcns.utils.StringUtil;
import cpcns.utils.Word2Pdf;
import cpcns.utils.mergePdf;
import freemarker.template.Configuration;
import freemarker.template.Template;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.Date;
import java.util.List;
import java.util.Map;
import org.apache.commons.lang.StringUtils;

public class createWord {
  public static String createWords_ws(List<Map<String, Object>> dataMap, Map<String, String> mbtype, String filePath) {
    String docName = null;
    String pdfName = null;
    String pdfPath = "";
    try {
      Configuration configuration = new Configuration();
      configuration.setDefaultEncoding("UTF-8");
      String temp = (new cpcns.utils.createWord()).getClass().getResource("/").getPath();
      temp = temp.substring(1);
      String temp_path = temp.replace("/WEB-INF/classes/", "/WEB-INF/template/");
      String dir = temp.replace("/WEB-INF/classes/", "/filePath");
      if (!StringUtil.IsSystem("win")) {
        temp_path = "/" + temp_path + "/";
        dir = "/" + dir;
      } 
      System.out.println("模版文件路径：" + temp_path);
      File ff = new File(StringUtil.dealBasePath(temp_path));
      configuration.setDirectoryForTemplateLoading(ff);
      String fp = StringUtil.dealBasePath(String.valueOf(filePath) + File.separator + "templateDoc" + File.separator);
      System.out.println("临时文件存放路径：" + fp);
      DangAnZhengLiUtil.deleteFilePath(fp);
      Writer out = null;
      if (dataMap != null && dataMap.size() > 0) {
        String jsonString = JsonWithJacksonUtils.getInstance().obj2Json(dataMap);
        jsonString = jsonString.replaceAll("<", "&lt;").replaceAll(">", "&gt;");
        dataMap = JsonWithJacksonUtils.getInstance().json2List(jsonString);
        for (int i = 0; i < dataMap.size(); i++) {
          String miji = (String)((Map)dataMap.get(i)).get("MIJI");
          String templateName = "";
          if (StringUtils.isNotBlank(miji) && !"null".equals(miji) && !"0".equals(miji)) {
            templateName = mbtype.get("2");
          } else {
            templateName = mbtype.get("1");
          } 
          Template template = configuration.getTemplate(templateName, "UTF-8");
          docName = String.valueOf(i) + ".doc";
          pdfName = String.valueOf(i) + ".pdf";
          File outFile = new File(String.valueOf(fp) + docName);
          if (!outFile.getParentFile().exists())
            outFile.getParentFile().mkdirs(); 
          out = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(outFile), "UTF-8"));
          Map<String, Object> map = dataMap.get(i);
          template.process(map, out);
          out.flush();
          out.close();
          Word2Pdf.doc2pdf(String.valueOf(fp) + docName, String.valueOf(fp) + pdfName);
          if (outFile.exists())
            outFile.delete(); 
        } 
      } 
      String fileName = String.valueOf(DateUtil.dateToFormat(new Date())) + ".pdf";
      System.out.println("合并后的文件存放路径：" + dir + "/" + fileName);
      mergePdf.mergePdfFiles(fp, fileName, dir);
      pdfPath = "/filePath/" + fileName;
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return pdfPath;
  }
  
  public static String createWords(List<Map<String, Object>> dataMap, String templateName, String filePath) {
    String docName = null;
    String pdfName = null;
    String pdfPath = "";
    try {
      Configuration configuration = new Configuration();
      configuration.setDefaultEncoding("UTF-8");
      String temp_path = (new cpcns.utils.createWord()).getClass().getResource("/").getPath();
      temp_path = temp_path.substring(1);
      temp_path = temp_path.replace("/WEB-INF/classes/", "/WEB-INF/template/");
      File ff = new File(temp_path);
      configuration.setDirectoryForTemplateLoading(ff);
      String fp = StringUtil.dealBasePath(String.valueOf(filePath) + File.separator + "templateDoc" + File.separator);
      Writer out = null;
      Template template = configuration.getTemplate(templateName, "UTF-8");
      if (dataMap != null && dataMap.size() > 0) {
        String jsonString = JsonWithJacksonUtils.getInstance().obj2Json(dataMap);
        jsonString = jsonString.replaceAll("<", "&lt;").replaceAll(">", "&gt;");
        dataMap = JsonWithJacksonUtils.getInstance().json2List(jsonString);
        for (int i = 0; i < dataMap.size(); i++) {
          docName = String.valueOf(i) + ".doc";
          pdfName = String.valueOf(i) + ".pdf";
          File outFile = new File(String.valueOf(fp) + docName);
          if (!outFile.getParentFile().exists())
            outFile.getParentFile().mkdirs(); 
          out = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(outFile), "UTF-8"));
          Map<String, Object> map = dataMap.get(i);
          template.process(map, out);
          out.flush();
          out.close();
          Word2Pdf.doc2pdf(String.valueOf(fp) + docName, String.valueOf(fp) + pdfName);
        } 
      } 
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return pdfPath;
  }
  
  public static String createWord(Map<String, Object> dataMap, String templateName, String filePath) {
    String docName = null;
    String pdfName = null;
    String pdfPath = "";
    try {
      Configuration configuration = new Configuration();
      configuration.setDefaultEncoding("UTF-8");
      String temp_path = (new cpcns.utils.createWord()).getClass().getResource("/").getPath();
      temp_path = temp_path.substring(1);
      temp_path = temp_path.replace("/WEB-INF/classes/", "/WEB-INF/template/");
      File ff = new File(temp_path);
      configuration.setDirectoryForTemplateLoading(ff);
      String fp = StringUtil.dealBasePath(String.valueOf(filePath) + File.separator + "templateDoc" + File.separator);
      Writer out = null;
      Template template = configuration.getTemplate(templateName, "UTF-8");
      if (dataMap != null && dataMap.size() > 0) {
        String jsonString = JsonWithJacksonUtils.getInstance().obj2Json(dataMap);
        jsonString = jsonString.replaceAll("<", "&lt;").replaceAll(">", "&gt;");
        dataMap = JsonWithJacksonUtils.getInstance().json2Map(jsonString);
        for (int i = 0; i < dataMap.size(); i++) {
          docName = String.valueOf(i) + ".doc";
          pdfName = String.valueOf(i) + ".pdf";
          File outFile = new File(String.valueOf(fp) + docName);
          if (!outFile.getParentFile().exists())
            outFile.getParentFile().mkdirs(); 
          out = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(outFile), "UTF-8"));
          Map<String, Object> map = (Map<String, Object>)dataMap.get(Integer.valueOf(i));
          template.process(map, out);
          out.flush();
          out.close();
          Word2Pdf.doc2pdf(String.valueOf(fp) + docName, String.valueOf(fp) + pdfName);
        } 
      } 
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return pdfPath;
  }
}
